//+--------------------------------------------------------------------+
//|                                            20/200 expert v3.mq4    |
//|                                                    1H   EUR/USD    |
//|                                                    Smirnov Pavel   |
//|                                                 www.autoforex.ru   |
//| The original EA by Pavel Smirnoy, modified, with a quite proper    |
//| optimization and additional function of the automated lot size.    |
//| And lot increasing to cover losses. After modification the EA      |
//| behaviour is not bad. But is still nonproductive. One can earn     |
//| more trading mamnually. tested in reality. Works like in the       |
//| tester. Recommended for a deposit from $10000. With lower          |
//| deposite profit is too small. Only for EUR/USD on 1H chart!!!!     |
//|                                                               AntS |
//+--------------------------------------------------------------------+

#property copyright "Smirnov Pavel"
#property link      "www.autoforex.ru"

extern int TakeProfit_L = 200; // Take Profit in points
extern int StopLoss_L = 2000;  // Stop Loss in points
extern int TakeProfit_S = 200; // Take Profit in points
extern int StopLoss_S = 2000;  // Stop Loss in points
extern int TradeTime=18;      // Time to enter the market
extern int t1=5;              
extern int t2=2;                
extern int delta_L=30;         
extern int delta_S=30;         
extern double lot = 0.5;      // Lot size
 int Orders=1;          // maximal number of positions opened at a time
 int MaxOpenTime=504;
extern int BigLotSize = 5;    // By how much lot size is multiplicated in Big lot
extern bool AutoLot=true;
extern int       MagicNumber=320101;

int ticket,total,cnt;
bool cantrade=true;
double closeprice;
double tmp;

int LotSize()
// The function opens a short position with lot size=volume
{
if (AccountBalance()>=300) lot=0.03;
if (AccountBalance()>=500) lot=0.05;
if (AccountBalance()>=1000) lot=0.10;
if (AccountBalance()>=2500) lot=0.25;
if (AccountBalance()>=5000) lot=0.50;
if (AccountBalance()>=10000) lot=1.00;
if (AccountBalance()>=20000) lot=2.00;
if (AccountBalance()>=30000) lot=3.00;
if (AccountBalance()>=40000) lot=4.00;
if (AccountBalance()>=50000) lot=5.00;
if (AccountBalance()>=60000) lot=6.00;
if (AccountBalance()>=70000) lot=7.00;
if (AccountBalance()>=80000) lot=8.00;
if (AccountBalance()>=90000) lot=9.00;
if (AccountBalance()>=100000) lot=10.00	;
if (AccountBalance()>=200000) lot=12.00	;
if (AccountBalance()>=300000) lot=13.00	;
if (AccountBalance()>=400000) lot=14.00	;
if (AccountBalance()>=500000) lot=15.00	;
if (AccountBalance()>=600000) lot=16.00	;
if (AccountBalance()>=700000) lot=17.00	;
if (AccountBalance()>=800000) lot=18.00	;
if (AccountBalance()>=900000) lot=19.00	;
if (AccountBalance()>=1000000) lot=20.00	;
}

int globPos()
// the function calculates big lot size
{
int v1=GlobalVariableGet("globalPosic");
GlobalVariableSet("globalPosic",v1+1);
  return(0);
}

int OpenLong(double volume=0.1)
// the function opens a long position with lot size=volume 
{
  int slippage=10;
  string comment="20/200 expert v2 (Long)";
  color arrow_color=Red;
  int MagicNumber=320101;

    if (GlobalVariableGet("globalBalans")>AccountBalance()) volume=lot*BigLotSize;
  //  if (GlobalVariableGet("globalBalans")>AccountBalance()) if (AutoLot) LotSize();
   
  ticket=OrderSend(Symbol(),OP_BUY,volume,Ask,slippage,Ask-StopLoss_L*Point,
                      Ask+TakeProfit_L*Point,comment,MagicNumber,0,arrow_color);
 
  GlobalVariableSet("globalBalans",AccountBalance());                    
  globPos();
//  if (GlobalVariableGet("globalPosic")>25)
//  {
  GlobalVariableSet("globalPosic",0);
  if (AutoLot) LotSize();
//  }
 
  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
    {
      return(0);
    }
    else
      {
        Print("OpenLong(),OrderSelect() - returned an error : ",GetLastError()); 
        return(-1);
      }   
  }
  else 
  {
    Print("Error opening Buy order : ",GetLastError()); 
    return(-1);
  }
}
  
int OpenShort(double volume=0.1)
// The function opens a short position with lot size=volume
{
  int slippage=10;
  string comment="20/200 expert v2 (Short)";
  color arrow_color=Red;
  int MagicNumber=320101;  

  if (GlobalVariableGet("globalBalans")>AccountBalance()) volume=lot*BigLotSize;
   
  ticket=OrderSend(Symbol(),OP_SELL,volume,Bid,slippage,Bid+StopLoss_S*Point,
                      Bid-TakeProfit_S*Point,comment,MagicNumber,0,arrow_color);
  GlobalVariableSet("globalBalans",AccountBalance());
  globPos();
//  if (GlobalVariableGet("globalPosic")>25)
//  {
  GlobalVariableSet("globalPosic",0);
  if (AutoLot) LotSize();
//  }

  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
    else
      {
        Print("OpenShort(),OrderSelect() - returned an error : ",GetLastError()); 
        return(-1);
      }    
  }
  else 
  {
    Print("Error opening Sell order : ",GetLastError()); 
    return(-1);
  }
}

int init()
{
  // control of a variable before using
  if (AutoLot) LotSize();
  if(!GlobalVariableCheck("globalBalans"))
    GlobalVariableSet("globalBalans",AccountBalance());
  if(!GlobalVariableCheck("globalPosic"))
    GlobalVariableSet("globalPosic",0);
  return(0);
}

int deinit()
{   
  return(0);
}

int start()
{
  if((TimeHour(TimeCurrent())>TradeTime)) cantrade=true;  
  // check if there are open orders ...
  total=OrdersTotal();
  if(total<Orders)
  {
    // ... if no open orders, go further
    // check if it's time for trade
    if((TimeHour(TimeCurrent())==TradeTime)&&(cantrade))
    {
      // ... if it is
      if (((Open[t1]-Open[t2])>delta_S*Point)) //if it is
      {
        //condition is fulfilled, enter a short position:
        // check if there is free money for opening a short position
        if(AccountFreeMarginCheck(Symbol(),OP_SELL,lot)<=0 || GetLastError()==134)
        {
          Print("Not enough money");
          return(0);
        }
        OpenShort(lot);
        
        cantrade=false; //prohibit repeated trade until the next bar
        return(0);
      }
      if (((Open[t2]-Open[t1])>delta_L*Point)) //if the price increased by delta
      {
        // condition is fulfilled, enter a long position
        // check if there is free money
        if(AccountFreeMarginCheck(Symbol(),OP_BUY,lot)<=0 || GetLastError()==134)
        {
          Print("Not enough money");
          return(0);
        }
        OpenLong(lot);
        
        cantrade=false;
        return(0);
      }
    }
  }
// block of a trade validity time checking, if MaxOpenTime=0, do not check.
   if(MaxOpenTime>0)
   {
      for(cnt=0;cnt<total;cnt++)
      {
         if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
         {
            tmp = (TimeCurrent()-OrderOpenTime())/3600.0;
               if (((NormalizeDouble(tmp,8)-MaxOpenTime)>=0))
               {     
                  RefreshRates();
                  if (OrderType()==OP_BUY)
                     closeprice=Bid;
                  else  
                     closeprice=Ask;          
                  if (OrderClose(OrderTicket(),OrderLots(),closeprice,10,Green))
                  {
                  Print("Forced closing of the trade - ",OrderTicket());
                     OrderPrint();
                  }
                  else 
                     Print("OrderClose() in block of a trade validity time checking returned an error - ",GetLastError());        
                  } 
               }
               else 
                  Print("OrderSelect() in block of a trade validity time checking returned an error - ",GetLastError());
         } 
      }     
      return(0);
   }